.\"     $NetBSD: cpu_coredump.9,v 1.8 2005/12/24 21:07:05 matt Exp $
.\"
.\" Copyright (c) 2002, 2005 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Gregory McGarry.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd December 24, 2005
.Dt CPU_COREDUMP 9
.Os
.Sh NAME
.Nm cpu_coredump
.Nd machine-dependent process core dump interface
.Sh SYNOPSIS
.In sys/signalvar.h
.Ft int
.Fn cpu_coredump "struct lwp *l" "void *iocookie" "struct core *chdr"
.Ft int
.Fn cpu_coredump32 "struct lwp *l" "void *iocookie" "struct core32 *chdr"
.Sh DESCRIPTION
.Fn cpu_coredump
is the machine-dependent interface invoked by machine-independent code
to dump the machine-dependent header information at the start of a
process core dump.
The header information primarily consists of the
CPU and floating-point registers.
.Fa l
is the lwp structure of the thread being dumped.
.Fa iocookie
is an opaque pointer to be passed to
.Fn coredump_write .
Information about the machine-dependent header sections are returned in
.Fa chdr .
.Pp
.Fn cpu_coredump
returns 0 on success and an appropriate error code on failure.
.Sh CODE REFERENCES
This section describes places within the
.Nx
source tree where actual code implementing or using the
machine-dependent coredump interface can be found.
All pathnames are relative to
.Pa /usr/src .
.Pp
Process core dumps are initiated within the file
.Pa sys/kern/kern_sig.c .
Process core dumps for ELF
.Nx
binaries are performed within the files
.Pa sys/kern/core_elf32.c
or
.Pa sys/kern/core_elf64.c .
Process core dumps for other
.Nx
binaries are performed within the file
.Pa sys/kern/core_netbsd.c .
.Sh SEE ALSO
.Xr coredump_write 9
